Apache log4cxx: Filter Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Filter Class Reference

Inherits OptionHandler, and ObjectImpl.

Inherited by AndFilter, DenyAllFilter, ExpressionFilter, LevelMatchFilter, LevelRangeFilter, LocationInfoFilter, MapFilter, PropertyFilter, and StringMatchFilter.

List of all members.

## Detailed Description

Users should extend this class to implement customized logging event filtering.

Note that Logger and AppenderSkeleton, the parent class of all standard appenders, have built-in filtering rules. It is suggested that you first use and understand the built-in rules before rushing to write your own custom filters.

This abstract class assumes and also imposes that filters be organized in a linear chain. The decide(LoggingEvent) method of each filter is called sequentially, in the order of their addition to the chain.

The decide(LoggingEvent) method must return one of the integer constants DENY, NEUTRAL or ACCEPT.

If the value DENY is returned, then the log event is dropped immediately without consulting with the remaining filters.

If the value NEUTRAL is returned, then the next filter in the chain is consulted. If there are no more filters in the chain, then the log event is logged. Thus, in the presence of no filters, the default behaviour is to log all logging events.

If the value ACCEPT is returned, then the log event is logged without consulting the remaining filters.

The philosophy of log4cxx filters is largely inspired from the Linux ipchains.

Note that filtering is only supported by the DOMConfigurator.

## Public Types
enum | FilterDecision { DENY = -1, NEUTRAL = 0, ACCEPT = 1 }
## Public Member Functions
| Filter ()
void | addRef () const
void | releaseRef () const
log4cxx::spi::FilterPtr | getNext () const
void | setNext (const log4cxx::spi::FilterPtr &newNext)
void | activateOptions (log4cxx::helpers::Pool &p)
| Usually filters options become active when set.
void | setOption (const LogString &option, const LogString &value)
| Set `option` to `value`.
virtual FilterDecision | decide (const LoggingEventPtr &event) const =0

## Member Enumeration Documentation

enum FilterDecision

  | Enumerator:
  DENY | The log event must be dropped immediately without consulting with the remaining filters, if any, in the chain.
  NEUTRAL | This filter is neutral with respect to the log event. The remaining filters, if any, should be consulted for a final decision.
  ACCEPT | The log event must be logged immediately without consulting with the remaining filters, if any, in the chain.

## Constructor & Destructor Documentation

Filter | ( |  | ) |

## Member Function Documentation

void activateOptions | ( | log4cxx::helpers::Pool & | p | ) | `[virtual]`

| Usually filters options become active when set. We provide a default do-nothing implementation for convenience. Implements OptionHandler. Reimplemented in ExpressionFilter, and LocationInfoFilter.

void addRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

virtual FilterDecision decide | ( | const LoggingEventPtr & | event | ) | const`[pure virtual]`

  | If the decision is `DENY`, then the event will be dropped. If the decision is `NEUTRAL`, then the next filter, if any, will be invoked. If the decision is ACCEPT then the event will be logged without consulting with other filters in the chain. Parameters:
  | event | The LoggingEvent to decide upon.
Returns: The decision of the filter. Implemented in AndFilter, DenyAllFilter, ExpressionFilter, LevelMatchFilter, LevelRangeFilter, LocationInfoFilter, MapFilter, PropertyFilter, and StringMatchFilter.

log4cxx::spi::FilterPtr getNext | ( |  | ) | const

void releaseRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

void setNext | ( | const log4cxx::spi::FilterPtr & | newNext | ) |

void setOption | ( | const LogString & | option,
|  | const LogString & | value
| ) | `[virtual]`

| Set `option` to `value`. The handling of each option depends on the OptionHandler instance. Some options may become active immediately whereas other may be activated only when activateOptions is called. Implements OptionHandler. Reimplemented in LevelMatchFilter, LevelRangeFilter, and StringMatchFilter.

The documentation for this class was generated from the following file:

- filter.h